## net.sf.saxon.pattern
Class ContentTypeTest

    java.lang.Object
      net.sf.saxon.pattern.NodeTest
          net.sf.saxon.pattern.ContentTypeTest

All Implemented Interfaces:
  ItemType, java.io.Serializable

public class ContentTypeTest
extends NodeTest

NodeTest is an interface that enables a test of whether a node matches particular conditions. ContentTypeTest tests for an element or attribute node with a particular type annotation.

See Also:
  Serialized Form

Constructor Summary
`ContentTypeTest(int nodeKind, SchemaType schemaType, Configuration config)` Create a ContentTypeTest

Method Summary
`AtomicType` `getAtomizedItemType()` Get the item type of the atomic values that will be produced when an item of this type is atomized (assuming that atomization succeeds)
`SchemaType` `getContentType()` Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes).
`double` `getDefaultPriority()` Determine the default priority of this node test when used on its own as a Pattern
`int` `getNodeKindMask()` Get a mask indicating which kinds of nodes this NodeTest can match.
`int` `getPrimitiveType()` Determine the types of nodes to which this pattern applies.
`SchemaType` `getSchemaType()`
`ItemType` `getSuperType()` Get the type from which this item type is derived by restriction.
`int` `hashCode()` Returns a hash code value for the object.
`boolean` `matches(int nodeKind, int fingerprint, int annotation)` Test whether this node test is satisfied by a given node
`boolean` `matches(NodeInfo node)` Test whether this node test is satisfied by a given node.
`java.lang.String` `toString()`

Methods inherited from class net.sf.saxon.pattern.NodeTest
`getFingerprint, getPrimitiveItemType, getRequiredNodeNames, matchesItem, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ContentTypeTest

    public ContentTypeTest(int nodeKind,
                           SchemaType schemaType,
                           Configuration config)

  Create a ContentTypeTest

Parameters:
  `nodeKind` - the kind of nodes to be matched: always elements or attributes
  `schemaType` - the required type annotation, as a simple or complex schema type
  `config` - the Configuration, supplied because this KindTest needs access to schema information

Method Detail

### getSchemaType

    public SchemaType getSchemaType()

### getSuperType

    public ItemType getSuperType()

  Description copied from interface: `ItemType`
  Get the type from which this item type is derived by restriction. This is the supertype in the XPath type heirarchy, as distinct from the Schema base type: this means that the supertype of xs:boolean is xdt:anyAtomicType, whose supertype is item() (rather than xs:anySimpleType).

  Specified by:
    `getSuperType` in interface `ItemType`
  Overrides:
    `getSuperType` in class `NodeTest`

### matches

    public boolean matches(int nodeKind,
                           int fingerprint,
                           int annotation)

  Test whether this node test is satisfied by a given node

  Specified by:
    `matches` in class `NodeTest`
  Parameters:
    `nodeKind` - The type of node to be matched
    `fingerprint` - identifies the expanded name of the node to be matched
    `annotation` - The actual content type of the node

### matches

    public boolean matches(NodeInfo node)

  Test whether this node test is satisfied by a given node. This alternative method is used in the case of nodes where calculating the fingerprint is expensive, for example DOM or JDOM nodes.

  Specified by:
    `matches` in class `NodeTest`
  Parameters:
    `node` - the node to be matched

### getDefaultPriority

    public final double getDefaultPriority()

  Determine the default priority of this node test when used on its own as a Pattern

  Specified by:
    `getDefaultPriority` in class `NodeTest`

### getPrimitiveType

    public int getPrimitiveType()

  Determine the types of nodes to which this pattern applies. Used for optimisation.

  Specified by:
    `getPrimitiveType` in interface `ItemType`
  Overrides:
    `getPrimitiveType` in class `NodeTest`
  Returns:
    the type of node matched by this pattern. e.g. Type.ELEMENT or Type.TEXT

### getNodeKindMask

    public int getNodeKindMask()

  Get a mask indicating which kinds of nodes this NodeTest can match. This is a combination of bits: 1<<Type.ELEMENT for element nodes, 1<<Type.TEXT for text nodes, and so on.

  Specified by:
    `getNodeKindMask` in class `NodeTest`

### getContentType

    public SchemaType getContentType()

  Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes). Return AnyType if there are no restrictions. The default implementation returns AnyType.

  Overrides:
    `getContentType` in class `NodeTest`

### getAtomizedItemType

    public AtomicType getAtomizedItemType()

  Get the item type of the atomic values that will be produced when an item of this type is atomized (assuming that atomization succeeds)

  Specified by:
    `getAtomizedItemType` in interface `ItemType`
  Overrides:
    `getAtomizedItemType` in class `NodeTest`

### toString

    public java.lang.String toString()

### hashCode

    public int hashCode()

  Returns a hash code value for the object.